CREATE TABLE IF NOT EXISTS Action (
    id SMALLINT PRIMARY KEY NOT NULL,
    name VARCHAR(32) NOT NULL
);

INSERT INTO Action(id, name)
VALUES (0, 'DENY')
ON CONFLICT DO NOTHING;

INSERT INTO Action(id, name)
VALUES (1, 'ALLOW')
ON CONFLICT DO NOTHING;


CREATE TABLE IF NOT EXISTS SensorKitType (
      id SMALLINT PRIMARY KEY NOT NULL,
      name VARCHAR(32) NOT NULL
    );

INSERT INTO SensorKitType(id, name)
VALUES (0, 'UNKNOWN')
ON CONFLICT DO NOTHING;

INSERT INTO SensorKitType(id, name)
VALUES (1, 'XP')
ON CONFLICT DO NOTHING;

INSERT INTO SensorKitType(id, name)
VALUES (2, 'WINDOWS')
ON CONFLICT DO NOTHING;

INSERT INTO SensorKitType(id, name)
VALUES (3, 'ANDROID')
ON CONFLICT DO NOTHING;

INSERT INTO SensorKitType(id, name)
VALUES (4, 'MAC')
ON CONFLICT DO NOTHING;

INSERT INTO SensorKitType(id, name)
VALUES (5, 'IOS')
ON CONFLICT DO NOTHING;

INSERT INTO SensorKitType(id, name)
VALUES (7, 'AV_SIG')
ON CONFLICT DO NOTHING;

INSERT INTO SensorKitType(id, name)
VALUES (10, 'OTHER')
ON CONFLICT DO NOTHING;

INSERT INTO SensorKitType(id, name)
VALUES (100, 'RHEL')
ON CONFLICT DO NOTHING;

INSERT INTO SensorKitType(id, name)
VALUES (101, 'UBUNTU')
ON CONFLICT DO NOTHING;

INSERT INTO SensorKitType(id, name)
VALUES (102, 'SUSE')
ON CONFLICT DO NOTHING;

INSERT INTO SensorKitType(id, name)
VALUES (103, 'AMAZON_LINUX')
ON CONFLICT DO NOTHING;

INSERT INTO SensorKitType(id, name)
VALUES (901, 'MAC_OSX')
ON CONFLICT DO NOTHING;


CREATE TABLE IF NOT EXISTS UpgradeConstraintMessage (
    id SERIAL PRIMARY KEY NOT NULL,
    message VARCHAR(254) NOT NULL
);


CREATE TABLE IF NOT EXISTS UpgradeConstraint (
    id UUID PRIMARY KEY DEFAULT uuid_generate_v1mc(),
    type SMALLINT references SensorKitType(id) NOT NULL,
    current_version_range VARCHAR(254) NOT NULL,
    target_version_range VARCHAR(254) NOT NULL,
    action SMALLINT references Action(id) NOT NULL,
    reason SMALLINT references UpgradeConstraintMessage(id) NOT NULL,
    UNIQUE(type, current_version_range, target_version_range)
);
CREATE INDEX IF NOT EXISTS idx_upgradeconstraint_type ON UpgradeConstraint (type);