CREATE TABLE IF NOT EXISTS OperationStatusChange(
    id BIGSERIAL PRIMARY KEY,
    operation UUID references Operation(id) NOT NULL,
    status VARCHAR(32) NOT NULL,
    status_reason VARCHAR(255),
    performed_at TIMESTAMP WITH TIME ZONE NOT NULL,
    updated_by VARCHAR(64) NOT NULL
);

-- add flag indicating if SCMS is enabled on the Operation - to be set during initialization
-- this allows us to query on SCMS sensors without working around tricky sensor version string
-- comparisons in queries
ALTER TABLE IF EXISTS Operation ADD COLUMN IF NOT EXISTS scms_enabled BOOLEAN NOT NULL DEFAULT false;